module Arke
  module Errors

    class InvalidHandler < StandardError; end

    class DeserializationError < StandardError

      def initialize(error)
        message = "There was an error deserializing the response, failed with error: #{error.class} - #{error.message}"
        super message
      end

    end

    class MissingType < StandardError; end

    class ConnectionRefused < StandardError

      def initialize(host)
        message = "There was an error connecting to the resource at #{host}"
        super message
      end

    end

    class MissingHandlerBlock < StandardError; end

  end
end