module Arke

  module Resource
    module Errors

      class ConnectionRefused < StandardError; end

      class UnexpectedResponse < StandardError; end

      class MethodNotAllowed < StandardError; end

      class NotFound < StandardError

        def initialize
          message = "The specificed resource was not found"
          super message
        end

      end

      class InternalServerError < StandardError; end

      class Exception < StandardError

        def initialize(resource)
          self.message = "An error on the specificed resource: Status Code #{resource.code}"
        end

      end

      class UnprocessableEntity < StandardError; end

    end
  end
end
