module Arke
  module Resource
    module Fields
      extend ActiveSupport::Concern


      module ClassMethods

        def field(name, options={})
          raise Errors::MissingType.new('The field type is required when defining a field.') unless options[:type]
          define_getter(name.to_s, options[:type])
          define_setter(name.to_s, options[:type])
        end

        private

        def define_getter(name, klass)
          instance_eval do
            define_method(name) do
              value = @_attributes[name]
              return value if klass == Boolean
              value ? klass.new(@_attributes[name]) : klass.new
            end
          end
        end

        def define_setter(name, klass)
          instance_eval do
            define_method("#{name}=") do |value|
              @_attributes[name] = value
            end
          end
        end


      end


    end
  end
end
