module Arke
  module Resource
    module Naming
      extend ActiveSupport::Concern

      included do
        delegate :singular_name, :resource_name, to: :class
      end

      module ClassMethods

        def resource_name
          self.name.tableize.split('/')[-1]
        end


        def singular_name
          resource_name.singularize
        end

      end
    end
  end
end